%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Converted_JT_Counter = Convert_RBE2_To_BS(Fastener_Index, Layer, Bar_Spider_PSet_Name)

global ErrCode;

global DB_MPC;
global AT_MPC;

global DB_FASTENERS;

% Инициализация счетчиков
Converted_JT_Counter = 0;

% Создание балочных элементов
Node_1 = DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer);
Node_2_list = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID)}.dep_grid;
Pset_Name = Bar_Spider_PSet_Name;
Pset_ID = Get_PSet_ID_From_Name(Bar_Spider_PSet_Name);
if (ErrCode < 0)
    fprintf (1, 'Как устранить данную ошибку: для конвертации RBE2 в "паук" из балок необходимо, чтобы в bdf файле существовал хотя бы один балочный элемент, имеющий property set [%s] !\n', Bar_Spider_PSet_Name);
    return;
end

Append_To_Output(PCL_Elm_Create_Bar_Spider(Node_1, Node_2_list, Pset_Name));
Created_Element_list = DB_Elm_Create_Bar_Spider(Node_1, Node_2_list, Pset_ID);

if (ErrCode < 0)
    return;
end

% Удаление RBE2
MPC_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID;

Append_To_Output(PCL_MPC_Delete(MPC_list));
DB_MPC_Delete(MPC_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
switch DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}
    case 'rbe2_2d_hole'
        DB_FASTENERS{Fastener_Index}.Joint_topology{Layer} = 'bar_spider_2d_hole';
    case 'rbe2_3d_hole'
        DB_FASTENERS{Fastener_Index}.Joint_topology{Layer} = 'bar_spider_3d_hole';
    otherwise
        fprintf (1, '\nНепредвиденная ошибка функции Convert_RBE2_To_BS !\n');
        ErrCode = -1;
        return;
end

DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID = [];
DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Bar_Spider_Elm_list = Created_Element_list;
DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Bar_Spider_Conn_Nodes_list = Node_2_list;

% Обновление счетчика
Converted_JT_Counter = 1;
